<html>
<head>
<title>OgreHardwarePixelBuffer.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreHardwarePixelBuffer.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreHardwarePixelBuffer_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __HardwarePixelBuffer__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __HardwarePixelBuffer__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="comment">// Precompiler options</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreHardwareBuffer_8h.html">OgreHardwareBuffer.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreSharedPtr_8h.html">OgreSharedPtr.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgrePixelFormat_8h.html">OgrePixelFormat.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreImage_8h.html">OgreImage.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre {
<a name="l00039"></a>00039 
<a name="l00052"></a><a class="code" href="classOgre_1_1HardwarePixelBuffer.html">00052</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1HardwarePixelBuffer.html" title="Specialisation of HardwareBuffer for a pixel buffer.">HardwarePixelBuffer</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1HardwareBuffer.html" title="Abstract class defining common features of hardware buffers.">HardwareBuffer</a>
<a name="l00053"></a>00053     {
<a name="l00054"></a>00054     <span class="keyword">protected</span>: 
<a name="l00055"></a>00055         <span class="comment">// Extents</span>
<a name="l00056"></a><a class="code" href="classOgre_1_1HardwarePixelBuffer.html#ae466eb08ea0efefbf95ad43a86a32b87">00056</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1HardwarePixelBuffer.html#ae466eb08ea0efefbf95ad43a86a32b87">mWidth</a>, mHeight, mDepth;
<a name="l00057"></a>00057         <span class="comment">// Pitches (offsets between rows and slices)</span>
<a name="l00058"></a><a class="code" href="classOgre_1_1HardwarePixelBuffer.html#acae5b713a65e3d0d5881ae02b3318d34">00058</a>         <span class="keywordtype">size_t</span> mRowPitch, <a class="code" href="classOgre_1_1HardwarePixelBuffer.html#acae5b713a65e3d0d5881ae02b3318d34">mSlicePitch</a>;
<a name="l00059"></a>00059         <span class="comment">// Internal format</span>
<a name="l00060"></a><a class="code" href="classOgre_1_1HardwarePixelBuffer.html#a715786c17620c4705b5caefa6b2cb2df">00060</a>         <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> <a class="code" href="classOgre_1_1HardwarePixelBuffer.html#a715786c17620c4705b5caefa6b2cb2df">mFormat</a>;
<a name="l00061"></a>00061         <span class="comment">// Currently locked region (local coords)</span>
<a name="l00062"></a><a class="code" href="classOgre_1_1HardwarePixelBuffer.html#a811656bfdacc1339fcba481c4bd8f6d1">00062</a>         <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a> <a class="code" href="classOgre_1_1HardwarePixelBuffer.html#a811656bfdacc1339fcba481c4bd8f6d1">mCurrentLock</a>;
<a name="l00063"></a>00063         <span class="comment">// The current locked box of this surface (entire surface coords)</span>
<a name="l00064"></a><a class="code" href="classOgre_1_1HardwarePixelBuffer.html#a31c838419dcf57b897bb50baad3fd423">00064</a>         <a class="code" href="structOgre_1_1Box.html" title="Structure used to define a box in a 3-D integer space.">Image::Box</a> <a class="code" href="classOgre_1_1HardwarePixelBuffer.html#a31c838419dcf57b897bb50baad3fd423">mLockedBox</a>;
<a name="l00065"></a>00065 
<a name="l00066"></a>00066         
<a name="l00068"></a>00068         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a> lockImpl(<span class="keyword">const</span> <a class="code" href="structOgre_1_1Box.html" title="Structure used to define a box in a 3-D integer space.">Image::Box</a> lockBox,  <a class="code" href="classOgre_1_1HardwareBuffer.html#aac34930556f611928ec9157c04bd1b0f" title="Locking options.">LockOptions</a> options) = 0;
<a name="l00069"></a>00069 
<a name="l00072"></a>00072         <span class="keyword">virtual</span> <span class="keywordtype">void</span>* lockImpl(<span class="keywordtype">size_t</span> offset, <span class="keywordtype">size_t</span> length, <a class="code" href="classOgre_1_1HardwareBuffer.html#aac34930556f611928ec9157c04bd1b0f" title="Locking options.">LockOptions</a> options);
<a name="l00073"></a>00073 
<a name="l00075"></a>00075         <span class="comment">// virtual void unlockImpl(void) = 0;</span>
<a name="l00076"></a>00076 
<a name="l00080"></a>00080         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _clearSliceRTT(<span class="keywordtype">size_t</span> zoffset);
<a name="l00081"></a><a class="code" href="classOgre_1_1HardwarePixelBuffer.html#a2548fc9744f5e43e0276d5627ca178de">00081</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1RenderTexture.html" title="This class represents a RenderTarget that renders to a Texture.">RenderTexture</a>;
<a name="l00082"></a>00082     <span class="keyword">public</span>:
<a name="l00084"></a>00084         <a class="code" href="classOgre_1_1HardwarePixelBuffer.html" title="Specialisation of HardwareBuffer for a pixel buffer.">HardwarePixelBuffer</a>(<span class="keywordtype">size_t</span> mWidth, <span class="keywordtype">size_t</span> mHeight, <span class="keywordtype">size_t</span> mDepth,
<a name="l00085"></a>00085                 <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> mFormat,
<a name="l00086"></a>00086                 <a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">HardwareBuffer::Usage</a> usage, <span class="keywordtype">bool</span> useSystemMemory, <span class="keywordtype">bool</span> useShadowBuffer);
<a name="l00087"></a>00087         ~<a class="code" href="classOgre_1_1HardwarePixelBuffer.html" title="Specialisation of HardwareBuffer for a pixel buffer.">HardwarePixelBuffer</a>();
<a name="l00088"></a>00088 
<a name="l00092"></a>00092         <span class="keyword">using</span> <a class="code" href="classOgre_1_1HardwareBuffer.html#ab1caebda1f7442706df97531c2d90aaf" title="Lock the buffer for (potentially) reading / writing.">HardwareBuffer::lock</a>; 
<a name="l00093"></a>00093 
<a name="l00100"></a>00100         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a>&amp; lock(<span class="keyword">const</span> <a class="code" href="structOgre_1_1Box.html" title="Structure used to define a box in a 3-D integer space.">Image::Box</a>&amp; lockBox, <a class="code" href="classOgre_1_1HardwareBuffer.html#aac34930556f611928ec9157c04bd1b0f" title="Locking options.">LockOptions</a> options);
<a name="l00102"></a>00102         <span class="keyword">virtual</span> <span class="keywordtype">void</span>* lock(<span class="keywordtype">size_t</span> offset, <span class="keywordtype">size_t</span> length, <a class="code" href="classOgre_1_1HardwareBuffer.html#aac34930556f611928ec9157c04bd1b0f" title="Locking options.">LockOptions</a> options);
<a name="l00103"></a>00103 
<a name="l00108"></a>00108         <span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a>&amp; getCurrentLock();
<a name="l00109"></a>00109         
<a name="l00111"></a>00111         <span class="keyword">virtual</span> <span class="keywordtype">void</span> readData(<span class="keywordtype">size_t</span> offset, <span class="keywordtype">size_t</span> length, <span class="keywordtype">void</span>* pDest);
<a name="l00113"></a>00113         <span class="keyword">virtual</span> <span class="keywordtype">void</span> writeData(<span class="keywordtype">size_t</span> offset, <span class="keywordtype">size_t</span> length, <span class="keyword">const</span> <span class="keywordtype">void</span>* pSource,
<a name="l00114"></a>00114                 <span class="keywordtype">bool</span> discardWholeBuffer = <span class="keyword">false</span>);
<a name="l00115"></a>00115         
<a name="l00126"></a>00126         <span class="keyword">virtual</span> <span class="keywordtype">void</span> blit(<span class="keyword">const</span> <a class="code" href="classOgre_1_1HardwarePixelBufferSharedPtr.html" title="Shared pointer implementation used to share pixel buffers.">HardwarePixelBufferSharedPtr</a> &amp;src, <span class="keyword">const</span> <a class="code" href="structOgre_1_1Box.html" title="Structure used to define a box in a 3-D integer space.">Image::Box</a> &amp;srcBox, <span class="keyword">const</span> <a class="code" href="structOgre_1_1Box.html" title="Structure used to define a box in a 3-D integer space.">Image::Box</a> &amp;dstBox);
<a name="l00127"></a>00127 
<a name="l00133"></a>00133         <span class="keywordtype">void</span> blit(<span class="keyword">const</span> <a class="code" href="classOgre_1_1HardwarePixelBufferSharedPtr.html" title="Shared pointer implementation used to share pixel buffers.">HardwarePixelBufferSharedPtr</a> &amp;src); 
<a name="l00134"></a>00134         
<a name="l00144"></a>00144         <span class="keyword">virtual</span> <span class="keywordtype">void</span> blitFromMemory(<span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a> &amp;src, <span class="keyword">const</span> <a class="code" href="structOgre_1_1Box.html" title="Structure used to define a box in a 3-D integer space.">Image::Box</a> &amp;dstBox) = 0;
<a name="l00145"></a>00145         
<a name="l00151"></a><a class="code" href="classOgre_1_1HardwarePixelBuffer.html#a2405dade15f595710a02903d302155bd">00151</a>         <span class="keywordtype">void</span> blitFromMemory(<span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a> &amp;src)
<a name="l00152"></a>00152         {
<a name="l00153"></a>00153             blitFromMemory(src, <a class="code" href="structOgre_1_1Box.html" title="Structure used to define a box in a 3-D integer space.">Box</a>(0,0,0,mWidth,mHeight,mDepth));
<a name="l00154"></a>00154         }
<a name="l00155"></a>00155         
<a name="l00163"></a>00163         <span class="keyword">virtual</span> <span class="keywordtype">void</span> blitToMemory(<span class="keyword">const</span> <a class="code" href="structOgre_1_1Box.html" title="Structure used to define a box in a 3-D integer space.">Image::Box</a> &amp;srcBox, <span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a> &amp;dst) = 0;
<a name="l00164"></a>00164 
<a name="l00170"></a><a class="code" href="classOgre_1_1HardwarePixelBuffer.html#a3d9ff2acd7776be35efd6fa24307012c">00170</a>         <span class="keywordtype">void</span> blitToMemory(<span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a> &amp;dst)
<a name="l00171"></a>00171         {
<a name="l00172"></a>00172             blitToMemory(<a class="code" href="structOgre_1_1Box.html" title="Structure used to define a box in a 3-D integer space.">Box</a>(0,0,0,mWidth,mHeight,mDepth), dst);
<a name="l00173"></a>00173         }
<a name="l00174"></a>00174         
<a name="l00182"></a>00182         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RenderTexture.html" title="This class represents a RenderTarget that renders to a Texture.">RenderTexture</a> *getRenderTarget(<span class="keywordtype">size_t</span> slice=0);
<a name="l00183"></a>00183         
<a name="l00185"></a><a class="code" href="classOgre_1_1HardwarePixelBuffer.html#abda31825eaf2b34edec2d0920c949e30">00185</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1HardwarePixelBuffer.html#abda31825eaf2b34edec2d0920c949e30" title="Gets the width of this buffer.">getWidth</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mWidth; }
<a name="l00187"></a><a class="code" href="classOgre_1_1HardwarePixelBuffer.html#a1a86fb9153a28f146a12c8db65ede66c">00187</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1HardwarePixelBuffer.html#a1a86fb9153a28f146a12c8db65ede66c" title="Gets the height of this buffer.">getHeight</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mHeight; }
<a name="l00189"></a><a class="code" href="classOgre_1_1HardwarePixelBuffer.html#ae6d2727151ff4574b70e3459aecf7faf">00189</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1HardwarePixelBuffer.html#ae6d2727151ff4574b70e3459aecf7faf" title="Gets the depth of this buffer.">getDepth</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mDepth; }
<a name="l00191"></a><a class="code" href="classOgre_1_1HardwarePixelBuffer.html#aee72f3e84af166ef031659478fea1967">00191</a>         <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> <a class="code" href="classOgre_1_1HardwarePixelBuffer.html#aee72f3e84af166ef031659478fea1967" title="Gets the native pixel format of this buffer.">getFormat</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mFormat; }
<a name="l00192"></a>00192     };
<a name="l00193"></a>00193 
<a name="l00195"></a><a class="code" href="classOgre_1_1HardwarePixelBufferSharedPtr.html">00195</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1HardwarePixelBufferSharedPtr.html" title="Shared pointer implementation used to share pixel buffers.">HardwarePixelBufferSharedPtr</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;HardwarePixelBuffer&gt;
<a name="l00196"></a>00196     {
<a name="l00197"></a>00197     <span class="keyword">public</span>:
<a name="l00198"></a><a class="code" href="classOgre_1_1HardwarePixelBufferSharedPtr.html#a18dcad0a29e66318250d10bf7e1780d9">00198</a>         <a class="code" href="classOgre_1_1HardwarePixelBufferSharedPtr.html#a18dcad0a29e66318250d10bf7e1780d9">HardwarePixelBufferSharedPtr</a>() : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1HardwarePixelBuffer.html" title="Specialisation of HardwareBuffer for a pixel buffer.">HardwarePixelBuffer</a>&gt;() {}
<a name="l00199"></a>00199         <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1HardwarePixelBufferSharedPtr.html" title="Shared pointer implementation used to share pixel buffers.">HardwarePixelBufferSharedPtr</a>(<a class="code" href="classOgre_1_1HardwarePixelBuffer.html" title="Specialisation of HardwareBuffer for a pixel buffer.">HardwarePixelBuffer</a>* buf);
<a name="l00200"></a>00200 
<a name="l00201"></a>00201 
<a name="l00202"></a>00202     };
<a name="l00203"></a>00203 
<a name="l00206"></a>00206 }
<a name="l00207"></a>00207 <span class="preprocessor">#endif</span>
<a name="l00208"></a>00208 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
